interface VerschluesselungT {
	// liefert den verschluesselten Text
	String verschluesseln(String klartext);
	
	// liefert den entschluesselten Text
	String entschluesseln(String geheimtext);
}

class GartenzaunTransposition implements VerschluesselungT {

	public String verschluesseln(String klartext) {
		String erg = "";
		for (int i = 0; i < klartext.length(); i += 2) {
			erg += klartext.charAt(i);
		}
		for (int i = 1; i < klartext.length(); i += 2) {
			erg += klartext.charAt(i);
		}
		return erg;
	}

	public String entschluesseln(String geheimtext) {
		String erg = "";
		for (int i = 0; i < (geheimtext.length() + 1) / 2; i++) {
			erg += geheimtext.charAt(i);
			if ((geheimtext.length() + 1) / 2 + i < geheimtext.length()) {
				erg += geheimtext.charAt((geheimtext.length() + 1) / 2 + i);
			}
		}
		return erg;
	}
}

public class UE20Aufgabe19 {

	public static void main(String[] args) {
		String eingabe = IO.readString("Text: ");
		VerschluesselungT v = new GartenzaunTransposition();
		String verschluesselt = v.verschluesseln(eingabe);
		System.out.println("Verschluesselt: " + verschluesselt);
		String entschluesselt = v.entschluesseln(verschluesselt);
		System.out.println("Entschluesselt: " + entschluesselt);
	}
}
