
public class UE20Aufgabe4 {

	// Hauptprogramm
	public static void main(String[] args) {
		String geheimtext = einlesen();
		double[] haeufigkeitstabelle = haeufigkeitErmitteln(geheimtext);
		haeufigkeitsabfrage(haeufigkeitstabelle);
	}

	// liest den Geheimtext ein
	public static String einlesen() {
		String eingabe;
		do {
			eingabe = IO.readString("String eingeben: ");
		} while (eingabe.length() == 0);
		return eingabe;
	}

	// berechnet Haeufigkeitstabelle (nur Kleinbuchstaben)
	public static double[] haeufigkeitErmitteln(String text) {
		int[] absTabelle = new int[26];
		for (int i = 0; i < text.length(); i++) {
			char zeichen = text.charAt(i);
			if (zeichen >= 'a' && zeichen <= 'z') {
				absTabelle[zeichen - 'a'] += 1;
			}
		}
		double[] prozTabelle = new double[26];
		for (int i = 0; i < 26; i++) {
			prozTabelle[i] = ((double) absTabelle[i]) / text.length() * 100.0;
		}
		return prozTabelle;
	}

	// Haeufigkeiten abfragen
	public static void haeufigkeitsabfrage(double[] tabelle) {
		while (true) {
			char antwort = IO.readChar("Weitere Abfragen (j/n)?");
			if (antwort != 'j')
				return;
			char buchstabe = IO.readChar("Prozentuale Haeufigkeit von: ");
			if (buchstabe >= 'a' && buchstabe <= 'z') {
				System.out.println("Prozentuale Haeufigkeit des Buchstabens "
						+ buchstabe + " im String = "
						+ tabelle[buchstabe - 'a'] + " %");
			} else {
				System.out.println(buchstabe + " ist kein Kleinbuchstabe!");
			}
		}
	}
}
