import java.util.ArrayList;
import java.util.Collections;

public class UE20Aufgabe28 {

	public static void main(String[] args) {
		String str = "rindfleischetikettierungsberwachungsaufgabenbertragungsgesetz";
		ArrayList<Buchstabe> buchstaben = berechneBuchstabenHaeufigkeit(str);
		Collections.sort(buchstaben);
		for (Buchstabe b : buchstaben) {
			System.out.print(b);
		}
	}

	static ArrayList<Buchstabe> berechneBuchstabenHaeufigkeit(String str) {
		ArrayList<Buchstabe> buchstaben = new ArrayList<Buchstabe>();
		for (char ch : str.toCharArray()) {
			int index = buchstaben.indexOf(new Buchstabe(ch));
			if (index != -1) {
				buchstaben.get(index).inkr();
			} else {
				buchstaben.add(new Buchstabe(ch));
			}
		}
		return buchstaben;
	}
}

class Buchstabe implements Comparable<Buchstabe> {
	private char buchstabe;
	private int haeufigkeit;

	public Buchstabe(char buchstabe) {
		this.buchstabe = buchstabe;
		this.haeufigkeit = 1;
	}

	@Override
	public boolean equals(Object obj) {
		return this.buchstabe == ((Buchstabe) obj).buchstabe;
	}

	@Override
	public String toString() {
		String res = "";
		for (int i = 0; i < this.haeufigkeit; i++) {
			res += this.buchstabe;
		}
		return res;
	}

	public void inkr() {
		this.haeufigkeit++;
	}

	public char getBuchstabe() {
		return this.buchstabe;
	}

	public int getHaeufigkeit() {
		return this.haeufigkeit;
	}

	@Override
	public int compareTo(Buchstabe b) {
		return this.buchstabe - b.buchstabe;
	}
}

